# Change Log

## 2.0.1

- Minor improvements to transcoding task management,
- Minor improvements to RTMP Client,
- Minor improvements to MSE Client,

## 2.0.0
- RTMP protocol support has been rewritten from scratch. You can now push and pull streams. It's also possible to restream an existing stream to another RTMP-compatible server. Authentication support has been added, along with Enhanced-RTMP capabilities (H.265 & VP1 codecs),
- Entirely new client-server protocol for Storm Library & Player. Thanks to "states," each player instance will be notified whenever a stream has started, been published, or ended,
- Storm now supports transcoding through FFMPEG (must be installed separately). Transcoding options can be further tuned via the preferences.xml file,
- Sockets can now be opened on multiple hosts & ports for specified protocols. RTMPS support has been added along with a new SSL engine,
- Socket restart functionality has been introduced (if a socket is already taken, the server will try to claim it at a specified interval),
- New application types have been introduced, including:
-- live - standard, single application group of streams,
-- origin - allows for pushing streams, but not for viewing. Designed for redistributing streams to other Storm instances,
-- edge - does not allow for pushing streams, but pools streams from specified origin applications,
- New authorization types for applications were added:
-- free - no authorization required for a specific application,
-- managed - a video stream with credentials (username & password or token) must be created first via API or Control Panel,
-- list - utilizes XML lists with credentials,
- Stream recording received additional options:
-- maximum storage for a specific folder can be specified,
-- whether to remove old files if a specified folder reaches its limit,
- Support for classic HLS/HLS-LS/MPEG-DASH has been introduced (works with 3rd party players),
- The threading component has been rewritten from scratch. The server is more efficient and uses 30% less RAM compared to version 1.x,
- A simple Control/Dev Panel has been introduced. The panel allows for basic server management, including killing or registering streams & connections,
- The RESTful API has been rewritten,
- The logger has been updated to Log4j2. Coloring is now supported and enabled by default,

## 1.5.0
- RestAPI has been greatly expanded now you have total control over all applications, streams, and auth users
- New SSL Engine for SSL connections
- RTMPS is now fully supported,
- Threadpools have been unified for all active socket listeners,
- RFC 7692 WebSocket protocol is now supported (works alongside 6455),
- Redesigned cluster mechanics for better performance,
- Major improvements in memory management

## 1.4.0
- Application settings VariableFPS & KeyFrameCompensation can now work in autodetect mode (new property value: auto),

## 1.3.1
- Minor improvements to memory management,

## 1.3.0
- DVR functionality on iOS was greatly improved,
- Improved thread-management,

## 1.2.3
- A bug allowing for application duplication was fixed,

## 1.2.2
- Log4j library was updated to the latest version,

## 1.2.1
- A minor bug in connection Timeout was fixed,

## 1.2.0
- A stream recoding functionality has been added to the server (can be configured by preferences.xml file),

## 1.1.5
- Minor bug fixes to External RTMP Module (Wowza WebRTC Compatibility),

## 1.1.4
- Minor improvements to WebSocket protocol,

## 1.1.3
- Docker config bug has been fixed,

## 1.1.2
- LL-HLS/HLS improvements for iOS 15 and Safari,

## 1.1.1
- Bug fix for RTMP internal connection source spamming erros after deleting a stream,
- VariableFPS parameter in application settings allows deciding whenever Strom should adjust for Variable Frame Rate source or not,
- KeyFrameCompensation parameter in application settings forces the packetizer to add missing keyframes,

## 1.1.0
- REST Module has been compeletly rewritten,
- New authentication system for REST,
- RTMP Client has been greatly improved,

## 1.0.1
- The bug where the client was not informed about a source that had been closed/ended was fixed,
- License type has been removed from the preferences.xml file,


## 1.0.0

- Initial release


